module DataImporter
  class CsvReader
    attr_accessor :csv, :headers, :seprator, :mappings

    def initialize(file_name, mappings=nil)
      @seprator = ","
      file = File.open(file_name, 'r')
      @csv = CSV.new(file, headers: true)
      @headers = File.open(file_name, 'r') {|f| f.readline.chomp}.split(@seprator)
      @mappings = mappings || get_default_mappings
    end

    def row
      @csv.shift
    end

    def get_mapped_row_hash
      csv_row = row
      return nil unless csv_row
      csv_row = csv_row.to_hash
      mappings.each { |mk, mv| csv_row[mv] = csv_row.delete(mk)}
      csv_row
    end

    private
    def get_default_mappings
      @headers.inject({}) {|mh, h| mh[h] = get_field_name(h); mh}
    end

    def get_field_name(field)
      field.downcase.gsub(/\s+/, ' ').gsub(" ","_").to_sym
    end
  end
end